import React from 'react';
import { Meta } from '@storybook/react';
import Tooltip, { TooltipProps } from '.';

export default {
  title: 'Components/Tooltip',
  component: Tooltip,
} as Meta<typeof Tooltip>;

export const TooltipBottom = (args: TooltipProps) => {
  return (
    <div className="flex m-5">
      <Tooltip {...args}>
        <h1>Hover over me</h1>
      </Tooltip>
    </div>
  );
};

TooltipBottom.args = {
  position: 'bottom',
  tooltip: 'This is a tooltip',
};

export const TooltipTop = (args: TooltipProps) => {
  return (
    <div className="flex m-5">
      <Tooltip {...args}>
        <h1>Hover over me</h1>
      </Tooltip>
    </div>
  );
};

TooltipTop.args = {
  position: 'top',
  tooltip: 'This is a tooltip',
};

export const TooltipLeft = (args: TooltipProps) => {
  return (
    <div className="flex m-5">
      <Tooltip {...args}>
        <h1>Hover over me</h1>
      </Tooltip>
    </div>
  );
};

TooltipLeft.args = {
  position: 'left',
  tooltip: 'This is a tooltip',
};

export const TooltipRight = (args: TooltipProps) => {
  return (
    <div className="flex m-5">
      <Tooltip {...args}>
        <h1>Hover over me</h1>
      </Tooltip>
    </div>
  );
};

TooltipRight.args = {
  position: 'right',
  tooltip: 'This is a tooltip',
};
