import { QueryMultiGraph } from '@graphpolaris/shared/lib/querybuilder';
import { DimensionType } from '@graphpolaris/shared/lib/schema';

export const extractAttributeDimensions = (qbGraph: QueryMultiGraph, elementType: 'entity' | 'relation') => {
  return qbGraph.nodes
    .filter((item) => item.attributes?.type === elementType)
    .reduce((acc: { [key: string]: { [key: string]: DimensionType } }, item) => {
      item.attributes?.attributes?.forEach((attribute) => {
        if (attribute.handleData && attribute.handleData.attributeName && attribute.handleData.attributeDimension) {
          const name: string = item.attributes?.name as string;
          acc[name] = acc[name] || {};
          acc[name][attribute.handleData.attributeName] = attribute.handleData.attributeDimension;
        }
      });
      return acc;
    }, {});
};
