import { DimensionType } from '../../../schema';

export type CategoricalStats = {
  uniqueItems: number;
};

export type NumericalStats = {
  minValue: number;
  maxValue: number;
  avgValue: number;
};

export type TemporalStats = {
  minDate: Date;
  maxDate: Date;
};

export type SpatialStats = {
  middlePoint: [number, number];
};

export type DimensionStatistics = CategoricalStats | NumericalStats | TemporalStats | SpatialStats;

export type DimensionInfoType = { [label: string]: { [attribute: string]: DimensionType } };

export type DimensionMap = {
  nodes: DimensionInfoType;
  edges: DimensionInfoType;
};

export type ElementStats = {
  dimension: DimensionType;
  stats?: DimensionStatistics;
};

export type ElementStatisticsType = {
  [label: string]: { [attribute: string]: ElementStats };
};

export interface GraphStatistics {
  nodes: ElementStatisticsType;
  edges: ElementStatisticsType;
}

export type CompressedElement = {
  [label: string]: { [attribute: string]: any };
};

export type CompressedGraph = {
  nodes: CompressedElement;
  edges: CompressedElement;
};
