import React, { useState, useEffect } from 'react';
import { useAppDispatch, useVisualizationState, useVisualizationSettings } from '@graphpolaris/shared/lib/data-access';
import ReactJSONView from 'react-json-view';
import { updateVisConfiguration } from '@graphpolaris/shared/lib/data-access/store/visualizationSlice';

export default function AdvancedPanel() {
  const dispatch = useAppDispatch();
  const vis = useVisualizationState();
  const settings = useVisualizationSettings();
  const [updatedSettings, setUpdatedSettings] = useState(settings);

  useEffect(() => {
    if (settings !== updatedSettings) {
      dispatch(updateVisConfiguration(updatedSettings));
    }
  }, [updatedSettings]);

  return (
    settings && (
      <div className="m-2">
        <ReactJSONView
          src={settings[vis.activeVisualization] || {}}
          name={false}
          collapsed={1}
          quotesOnKeys={false}
          displayDataTypes={false}
          onEdit={(v) => setUpdatedSettings(v.updated_src as any)}
        />
      </div>
    )
  );
}
