import React, { useState, useEffect } from 'react';
import { EncodingSelector } from './selectors';
import { useGraphQueryResultStats } from '@graphpolaris/shared/lib/data-access';
import { ElementStats } from '@graphpolaris/shared/lib/data-access/utils/result-statistics';

type Props = {
  selectorType: keyof typeof EncodingSelector;
  marking: any;
  onChange: (val: any) => void;
  accessorPath: string;
};

export default function Selector({ selectorType, marking, onChange, accessorPath }: Props) {
  const graphStatistics = useGraphQueryResultStats();
  const [statistics, setStatistics] = useState<ElementStats | undefined>();

  const SelectorComponent = EncodingSelector[selectorType];

  const getStatisticsFromAccessorPath = (accessorPath: string): ElementStats | undefined => {
    return undefined;
  };

  useEffect(() => {
    const attributeStatistics = getStatisticsFromAccessorPath(accessorPath);
    setStatistics(attributeStatistics);
  }, []);

  return <SelectorComponent marking={marking} onChange={onChange} statistics={statistics} />;
}
