import React, { useEffect, useState } from 'react';
import { useAppDispatch, useVisInteractions } from '@graphpolaris/shared/lib/data-access';
import { updateVisInteractions } from '@graphpolaris/shared/lib/data-access/store/visualizationSlice';

export default function InteractionPanel() {
  const dispatch = useAppDispatch();
  const interactions = useVisInteractions();
  const [interactionUpdates, setInteractionUpdates] = useState(interactions);

  useEffect(() => {
    if (interactions !== interactionUpdates) {
      dispatch(updateVisInteractions(interactionUpdates));
      console.debug('Interactions updated');
    }
  }, [interactionUpdates]);

  return (
    interactions && (
      <div>
        <p>Interaction settings</p>
      </div>
    )
  );
}
