import React, { useState } from 'react';
import { FormActions, FormBody, FormCard, FormDiv, FormHBar } from '@graphpolaris/shared/lib/components/forms';
import { DialogProps } from '@graphpolaris/shared/lib/components/Dialog';
import PanelHeader from './panel-header';
import { SettingsPanel } from '../settings';
import { AdvancedPanel } from '../advanced';
import { EncodingPanel } from '../encodings';
import { InteractionPanel } from '../interactions';

export default function VisualizationDialog(props: DialogProps) {
  const [activeTab, setActiveTab] = useState<number>(1);

  return (
    <>
      {props.open && (
        <FormDiv>
          <FormCard>
            <FormBody
              onSubmit={(e) => {
                e.preventDefault();
                props.onClose();
              }}
            >
              <PanelHeader onClose={props.onClose} activeTab={activeTab} setActiveTab={setActiveTab} />
              {activeTab === 0 && <EncodingPanel />}
              {activeTab === 1 && <SettingsPanel />}
              {activeTab === 2 && <InteractionPanel />}
              {activeTab === 3 && <AdvancedPanel />}
              <FormHBar />
              <FormActions onClose={props.onClose} />
            </FormBody>
          </FormCard>
        </FormDiv>
      )}
    </>
  );
}
