import React from 'react';
import Tooltip from '@graphpolaris/shared/lib/components/tooltip';

type TabItemProps = {
  active: boolean;
  onClick: () => void;
  icon: JSX.Element;
  tooltip: string;
};

export default function TabItem({ active, onClick, icon, tooltip }: TabItemProps) {
  return (
    <li
      className={`me-2 inline-block bg-secondary-100 cursor-pointer ${active && 'border-b-2 border-primary-200 text-primary-200'}`}
      onClick={onClick}
    >
      <Tooltip tooltip={tooltip}>{icon}</Tooltip>
    </li>
  );
}
