import { GraphQueryResult } from '../data-access/store/graphQueryResultSlice';
import { ML } from '../data-access/store/mlSlice';
import { SchemaGraph } from '../schema';
import type { AppDispatch } from '../data-access';
import { InputProps } from '../components/inputs';
import { FC } from 'react';
import { EncodingProps, EncodingTypes } from './configuration/encodings';
import { SettingProps, SettingTypes } from './configuration/settings';
import { InteractionProps, InteractionTypes } from './configuration/interactions';
import { Visualizations } from './visualizationManager';

export type globalConfigTypes = { [id: string]: InputProps };

export type globalConfigPropTypes = { [K in keyof globalConfigTypes]: any };

export type VisualizationConfiguration = {
  settings?: SettingTypes;
  encodings?: EncodingTypes;
  interactions?: InteractionTypes;
};

export type VISComponentType = {
  displayName: keyof typeof Visualizations;
  VIS: FC<any>;
  settings?: SettingTypes;
  encodings?: EncodingTypes;
  interactions?: InteractionTypes;
};

export type VisualizationPropTypes = {
  data: GraphQueryResult;
  schema: SchemaGraph;
  ml: ML;
  dispatch: AppDispatch;
  globalConfig: globalConfigPropTypes;
  settings: SettingProps;
  encodings?: EncodingProps;
  interactions?: InteractionProps;
};
