import React, { useEffect } from 'react';
import ReactJSONView from 'react-json-view';
import { VisualizationPropTypes, VISComponentType } from '../../types';

export interface RawJSONVisProps {}

const displayName = 'RawJSONVis';

export const RawJSONVis = React.memo(({ data }: VisualizationPropTypes) => {
  useEffect(() => {
    console.log('update rawjson useEffect');
  }, [data]);

  return (
    <div>
      <div style={{ overflowY: 'auto' }}>
        <div
          style={{
            marginTop: '50px',
            paddingLeft: '30px',
          }}
          className="font-mono text-sm"
        >
          <ReactJSONView src={data} collapsed={1} quotesOnKeys={false} displayDataTypes={false} />
        </div>
      </div>
    </div>
  );
});

export const RawJSONComponent: VISComponentType = {
  displayName: 'RawJSONVis',
  VIS: RawJSONVis,
  settings: {},
};
export default RawJSONComponent;
